/// <reference types="react" />
import { Tensorboard } from '../tensorboard';
import { TensorboardManager } from '../manager';
export interface TensorboardCreatorProps {
    disable: boolean;
    getCWD: () => string;
    openDoc: () => void;
    startTensorBoard: (logDir: string, reloadInterval: number) => void;
}
export interface TensorboardTabReactProps {
    createdModelName?: string;
    tensorboardManager: TensorboardManager;
    closeWidget: () => void;
    getCWD: () => string;
    openTensorBoard: (modelName: string, copy: boolean) => void;
    openDoc: () => void;
    update: () => void;
    updateCurrentModel: (model: Tensorboard.IModel) => void;
}
export declare const TensorboardTabReact: (props: TensorboardTabReactProps) => JSX.Element;
export declare namespace TensorboardTab {
    /**
     * Options of the tensorboard widget.
     */
    interface IOptions {
        /**
         * The model of tensorboard instance.
         */
        readonly model: Tensorboard.IModel;
    }
}
