import { JupyterFrontEnd, JupyterFrontEndPlugin } from '@jupyterlab/application';
import { WidgetTracker, IWidgetTracker, MainAreaWidget } from '@jupyterlab/apputils';
import { ILauncher } from '@jupyterlab/launcher';
import { IMainMenu } from '@jupyterlab/mainmenu';
import { IFileBrowserFactory } from '@jupyterlab/filebrowser';
import { TensorboardManager } from './manager';
import { LabIcon } from '@jupyterlab/ui-components';
import { TensorboardTabReactWidget } from './biz/widget';
export declare const tensorboardIcon: LabIcon;
/**
 * Initialization data for the tensorboard extension.
 */
declare const extension: JupyterFrontEndPlugin<IWidgetTracker<MainAreaWidget<TensorboardTabReactWidget>>>;
export default extension;
/**
 * Add the commands for the tensorboard.
 */
export declare function addCommands(app: JupyterFrontEnd, manager: TensorboardManager, tracker: WidgetTracker<MainAreaWidget<TensorboardTabReactWidget>>, browserFactory: IFileBrowserFactory, launcher: ILauncher | null, menu: IMainMenu | null): void;
